app/home/forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, BooleanField, SubmitField, SelectField, TextAreaField,IntegerField,RadioField, DecimalField
from wtforms.validators import DataRequired, Email, EqualTo, Length
from wtforms import ValidationError, validators
from flask_babel import lazy_gettext as _l
from app.models.user import User
from flask import request
from flask_uploads import UploadSet, configure_uploads, IMAGES
from flask_wtf.file import FileField, FileRequired, FileAllowed
from flask_wtf.recaptcha import RecaptchaField
photos = UploadSet('photos', IMAGES)

class SearchForm(FlaskForm):
    year = SelectField(coerce=int,id="car-years")
    make = SelectField(id="car-makes")
    model =SelectField(id="car-models")
    transmission =SelectField(choices=[('transmission', '--Transmission Type--'),('Automatic', 'Automatic'), ('Manual', 'Manual')],id="car-trans")
    fuel =SelectField(choices=[('fuel', '--Fuel Type--'),('Petrol', 'Petrol'), ('Diesel', 'diesel')],id="car-fuel")
    submit = SubmitField('FIND A CAR')

    def __init__(self, *args, **kwargs):
        if 'formdata' not in kwargs:
            kwargs['formdata'] = request.args
        if 'csrf_enabled' not in kwargs:
            kwargs['csrf_enabled'] = False
        super(SearchForm, self).__init__(*args, **kwargs)

class SellcarForm(FlaskForm):
    year = SelectField(validators=[DataRequired()],coerce=int,id="car-years")
    make = SelectField(validators=[DataRequired()],id="car-makes")
    model =SelectField(validators=[DataRequired()],id="car-models")
    name = StringField(validators=[DataRequired()])
    phone_number = StringField(validators=[DataRequired()])
    email = StringField('email', validators=[DataRequired(), Email()])
    description = TextAreaField(validators=[DataRequired()])
    submit = SubmitField('SUBMIT')

class ContactForm(FlaskForm):
    first_name = StringField(validators=[DataRequired()])
    last_name  = StringField(validators=[DataRequired()])
    phone_number = StringField(validators=[DataRequired()])
    email = StringField('email', validators=[DataRequired(), Email()])
    description = TextAreaField(validators=[Length(min=20, max=300)])
    subscribe = BooleanField('Subscribe and Get latest updates and offers by Email')
    recaptcha = RecaptchaField()
    submit = SubmitField('SUBMIT')

class ImportcarForm(FlaskForm):
    year = SelectField(validators=[DataRequired()],coerce=int,id="car-years")
    make = SelectField(validators=[DataRequired()],id="car-makes")
    model =SelectField(validators=[DataRequired()],id="car-models")
    name = StringField(validators=[DataRequired()])
    budget = DecimalField(validators=[DataRequired()])
    phone_number = StringField(validators=[DataRequired()])
    email = StringField('email', validators=[DataRequired(), Email()])
    description = TextAreaField(validators=[DataRequired()])
    submit = SubmitField('SUBMIT')

class TradeinForm(FlaskForm):
    year = SelectField(validators=[DataRequired()],coerce=int,id="car-years")
    make = SelectField(validators=[DataRequired()],id="car-makes")
    model =SelectField(validators=[DataRequired()],id="car-models")
    transmission =SelectField(validators=[DataRequired()],choices=[('automatic', 'Automatic'), ('manual', 'Manual')])
    mileage =StringField(validators=[DataRequired()])
    vin = StringField(validators=[DataRequired()])
    image = FileField(validators=[FileAllowed(photos, u'Image only!')])
    exterior_color = StringField(validators=[DataRequired()])
    interior_color = StringField(validators=[DataRequired()])
    exterior_condition = RadioField(validators=[DataRequired()],choices=[('extra-clean','Extra clean'),('clean','Clean'),('average','Average'),('below-average','Below Average'),('dont-know',"I don't know")])
    interior_condition = RadioField(validators=[DataRequired()],choices=[('extra-clean','Extra clean'),('clean','Clean'),('average','Average'),('below-average','Below Average'),('dont-know',"I don't know")])
    accident = RadioField(validators=[DataRequired()],choices=[('yes','Yes'),('no','NO'),('dont-know',"I don't know")])
    name = StringField(validators=[DataRequired()])
    phone_number = StringField(validators=[DataRequired()])
    email = StringField('email', validators=[DataRequired(), Email()])
    comments = TextAreaField(validators=[DataRequired()])
    submit = SubmitField('SUBMIT')

app/home/__init__.py
from flask import Blueprint

bp = Blueprint('home', __name__)


from app.home import routes

app/home/routes.py
from datetime import datetime
from flask import render_template, flash, redirect, abort, url_for, request, g, jsonify, current_app
from flask_login import current_user, login_required
from flask_uploads import UploadSet, configure_uploads, IMAGES
from app import db
from flask import Blueprint
from app.models import *
from app.home import bp
from app.home.forms import *
from sqlalchemy import and_
photos = UploadSet('photos', IMAGES)

@bp.before_app_request
def before_request():
    if current_user.is_authenticated:
        current_user.last_seen = datetime.utcnow()
        db.session.commit()
    g.company = Company.query.first()
    g.images = Theme.query.first()


@bp.route('/')
@bp.route('/index')
def index():
    form=SearchForm()
    make=[(row.make, row.make) for row in Vehicle.query.group_by(Vehicle.make)]
    make.insert(0, ('make','--Any make--'))
    year=[(row.year, row.year) for row in Year.query.order_by(Year.year.desc()).all()]
    year.insert(0, (0,'--Any year--'))
    model=[(row.model, row.model) for row in Vehicle.query.group_by(Vehicle.model)]
    model.insert(0, ('model','--Any model--'))
    form.year.choices=year
    form.make.choices=make
    form.model.choices=model
    featured = Inventory.query.filter_by(state='available',featured=True).order_by(Inventory.created_at.desc()).limit(4)
    return render_template('home/index.html',form=form, featured=featured)

@bp.route('/contact_us', methods=['GET', 'POST'])
def contact_us():
    form=ContactForm()
    if form.validate_on_submit():
        contact = Contact(first_name=form.first_name.data,last_name=form.last_name.data, phone_number=form.phone_number.data,email=form.email.data,description=form.description.data,subscribe=form.subscribe.data)
        db.session.add(contact)
        db.session.commit()
        flash('Request sent successfully! We will get back to you as soon as possible ', 'success')
        return redirect(url_for('home.contact_us'))
    return render_template('home/contactus.html',form=form)

@bp.route('/financing')
def financing():
    return render_template('home/financing.html')

@bp.route('/imports', methods=['GET', 'POST'])
def imports():
    form=ImportcarForm()
    make=[(row.make, row.make) for row in Vehicle.query.group_by(Vehicle.make)]
    make.insert(0, (0,'--Any make--'))
    year=[(row.year, row.year) for row in Year.query.order_by(Year.year.desc()).all()]
    year.insert(0, (0,'--choose year--'))
    model=[(row.model, row.model) for row in Vehicle.query.group_by(Vehicle.model)]
    model.insert(0, (0,'--choose model--'))
    form.year.choices=year
    form.make.choices=make
    form.model.choices=model
    if form.validate_on_submit():
        model= Vehicle.query.filter_by(make=form.make.data,model=form.model.data).first_or_404()
        car = Importcar(vehicle=model,year=form.year.data,name=form.name.data,budget=form.budget.data, phone_number=form.phone_number.data,email=form.email.data,description=form.description.data)
        db.session.add(car)
        db.session.commit()
        flash('Request sent successfully! We will get back to you as soon as possible ', 'success')
        return redirect(url_for('home.imports'))
    return render_template('home/import.html',form=form)

@bp.route('/inventory')
def inventory():
    form=SearchForm()
    make=[(row.make, row.make) for row in Vehicle.query.group_by(Vehicle.make)]
    make.insert(0, ('make','--Any make--'))
    year=[(row.year, row.year) for row in Year.query.order_by(Year.year.desc()).all()]
    year.insert(0, (0,'--Any year--'))
    model=[(row.model, row.model) for row in Vehicle.query.group_by(Vehicle.model)]
    model.insert(0, ('model','--Any model--'))
    form.year.choices=year
    form.make.choices=make
    form.model.choices=model
    page = request.args.get('page', 1, type=int)
    inventory = Inventory.query.filter_by(state='available').order_by(Inventory.created_at.desc()).paginate(page,current_app.config['POSTS_PER_PAGE'],False)
    featured = Inventory.query.filter_by(state='available',featured=True).order_by(Inventory.created_at.desc()).limit(3)
    maxlist=Inventory.query.all()
    maxval =  int(max(node.price for node in maxlist )) if maxlist else  None
    if request.args.get('year') and form.validate():
        page = request.args.get('page', 1, type=int)
        year = form.year.data
        make = form.make.data
        model = form.model.data
        fuel = form.fuel.data
        trans = form.transmission.data
        inventory = Inventory.get_inventory_filters(make,model,year,fuel,trans,page)
    elif request.args.get('body'):
        body = request.args.get('body', '01', type=str)
        inventory =Inventory.query.filter(and_(Inventory.body.like('%' + body.capitalize() + '%'),Inventory.state=='available')).order_by(Inventory.created_at.desc()).paginate(page,current_app.config['POSTS_PER_PAGE'],False)
    next_url = url_for('home.inventory', page=inventory.next_num) if inventory.has_next else None
    prev_url = url_for('home.inventory', page=inventory.prev_num) if inventory.has_prev else None
    return render_template('home/inventory.html', inventories=inventory.items,form=form,featured=featured, next_url=next_url, prev_url=prev_url,maxval=maxval)

@bp.route('/sell_your_car', methods=['GET', 'POST'])
def sell_your_car():
    form=SellcarForm()
    make=[(row.make, row.make) for row in Vehicle.query.group_by(Vehicle.make)]
    make.insert(0, (0,'--choose make--'))
    year=[(row.year, row.year) for row in Year.query.order_by(Year.year.desc()).all()]
    year.insert(0, (0,'--choose year--'))
    model=[(row.model, row.model) for row in Vehicle.query.group_by(Vehicle.model)]
    model.insert(0, (0,'--choose model--'))
    form.year.choices=year
    form.make.choices=make
    form.model.choices=model
    if form.validate_on_submit():
        model= Vehicle.query.filter_by(make=form.make.data,model=form.model.data).first_or_404()
        car = Sellcar(vehicle=model,name=form.name.data,year=form.year.data, phone_number=form.phone_number.data,email=form.email.data,description=form.description.data)
        db.session.add(car)
        db.session.commit()
        flash('Request sent successfully! We will get back to you as soon as possible ', 'success')
        return redirect(url_for('home.sell_your_car'))
    return render_template('home/sellyourcar.html',form=form)

@bp.route('/tips')
def tips():
    return render_template('home/tips.html')

@bp.route('/trade_in', methods=['GET', 'POST'])
def trade_in():
    form=TradeinForm()
    make=[(row.make, row.make) for row in Vehicle.query.group_by(Vehicle.make)]
    make.insert(0, (0,'--choose make--'))
    year=[(row.year, row.year) for row in Year.query.order_by(Year.year.desc()).all()]
    year.insert(0, (0,'--choose year--'))
    model=[(row.model, row.model) for row in Vehicle.query.group_by(Vehicle.model)]
    model.insert(0, (0,'--choose model--'))
    form.year.choices=year
    form.make.choices=make
    form.model.choices=model
    if form.validate_on_submit():
        image = form.image.data
        if image is not None:
            image = photos.save(form.image.data)
        model= Vehicle.query.filter_by(make=form.make.data,model=form.model.data).first_or_404()
        car = Tradein(vehicle=model,name=form.name.data,year=form.year.data, phone_number=form.phone_number.data,email=form.email.data,comments=form.comments.data,transmission=form.transmission.data,
                      mileage=form.mileage.data,vin=form.vin.data,image=image,exterior_color=form.exterior_color.data,interior_color=form.interior_color.data,exterior_condition=form.exterior_condition.data,
                      interior_condition=form.interior_condition.data,accident=form.accident.data)
        db.session.add(car)
        db.session.commit()
        flash('Request sent successfully! We will get back to you as soon as possible ', 'success')
        return redirect(url_for('home.trade_in'))
    return render_template('home/tradein.html',form=form)

@bp.route('/_get_cars/')
def _get_cars():
    min_val = request.args.get('min_price', '01', type=int)
    max_val = request.args.get('max_price', '01', type=int)
    page = request.args.get('page', 1, type=int)
    data={}
    inventory =Inventory.query.filter(Inventory.price >= min_val).filter(Inventory.price <= max_val).filter(Inventory.state=='available').order_by(Inventory.created_at.desc()).paginate(page,current_app.config['POSTS_PER_PAGE'],False)
    next_url = url_for('home.inventory', page=inventory.next_num) if inventory.has_next else None
    prev_url = url_for('home.inventory', page=inventory.prev_num) if inventory.has_prev else None
    #dont delete
    # for index,list in enumerate(inventory):
    #     data.update({index:{
    #                 'price': list.price,
    #                 'mileage': list.mileage,
    #                 'image': list.image,
    #                 'fuel': list.fuel,
    #                 'year': list.vehicle.year,
    #                 'make': list.vehicle.make,
    #                 'model':list.vehicle.model if list else  None}})
    # print(data)
    # return jsonify(data)
    return render_template('home/_post.html', inventories=inventory.items,next_url=next_url, prev_url=prev_url)

@bp.route('/_get_body')
def _get_body():
    data = request.args
    list=Inventory.to_dict_body(data)
    page = request.args.get('page', 1, type=int)
    inventory =Inventory.query.filter_by(state='available').order_by(Inventory.created_at.desc()).paginate(page,current_app.config['POSTS_PER_PAGE'],False)
    if list:
        inventory =Inventory.query.filter(Inventory.body.in_(list)).filter(Inventory.state=='available').order_by(Inventory.created_at.desc()).paginate(page,current_app.config['POSTS_PER_PAGE'],False)
    next_url = url_for('home.inventory', page=inventory.next_num) if inventory.has_next else None
    prev_url = url_for('home.inventory', page=inventory.prev_num) if inventory.has_prev else None

app/templates/home/_feature.html
<div class="col-md-3 col-sm-6 col-xs-12 wow fadeIn">
    <div class="car-wrapper clearfix">
        <div class="post-media entry">
            <img src="{% if feature.image %}{{url_for('static', filename='uploads/{}'.format(feature.image))}}{% else %}{{url_for('static', filename='img/placeholder.png')}}{% endif %}" style="height:200px" alt="" class="img-responsive">
            <div class="magnifier">
            </div><!-- end magnifier -->
            <div class="car-price"><p>{% if feature.external_price %}{{ "Ksh. {:,.2f}".format(feature.external_price) }}{% endif %}</p></div>
            <ul class="list-inline">
                <li class="car-km"><p><i class="fa fa-road"></i>{{ feature.mileage }}</p></li>
                <li class="car-oil"><p><i class="fa fa-car"></i> {{ feature.fuel }}</p></li>
                <li class="car-date"><p><i class="fa fa-clock-o"></i> {{ feature.year }}</p></li>
            </ul>
        </div>
        <div class="car-title clearfix gigimotors">
            <h4><a href="#">{{ feature.vehicle.make }} {{ feature.vehicle.model }}</a></h4>
        </div><!-- end car-title -->
    </div><!-- end clearfix -->
</div>

app/templates/home/_post.html
{% if inventories %}
<div id="inventory" class="row grid-wrapper">
  {% for inventory in inventories %}
    <div class="col-md-4 col-sm-6 col-xs-12 wow fadeIn">
        <div class="car-wrapper clearfix">
            <div class="post-media entry">
                <img src="{% if inventory.image %}{{url_for('static', filename='uploads/{}'.format(inventory.image))}}{% else %}{{url_for('static', filename='img/placeholder.png')}}{% endif %}" style="height:200px" alt="" class="img-responsive">
                <div class="magnifier">
                </div><!-- end magnifier -->
                <div class="car-price"><p>{% if inventory.external_price %}{{ "Ksh. {:,.2f}".format(inventory.external_price) }}{% endif %}</p></div>
                <ul class="list-inline">
                    <li class="car-km"><p><i class="fa fa-road"></i>{{ inventory.mileage }}</p></li>
                    <li class="car-oil"><p><i class="fa fa-car"></i> {{ inventory.fuel }}</p></li>
                    <li class="car-date"><p><i class="fa fa-clock-o"></i> {{ inventory.year }}</p></li>
                </ul>
            </div>
            <div class="car-title clearfix gigimotors">
                <h4><a href="#">{{ inventory.vehicle.make }} {{ inventory.vehicle.model }}</a></h4>
            </div><!-- end car-title -->
        </div><!-- end clearfix -->
    </div>
    {% endfor %}
</div><!-- end row -->
<div class="row">
<nav aria-label="...">
   <ul class="pager">
       <li class="previous{% if not prev_url %} disabled{% endif %}">
           <a href="{{ prev_url or '#' }}">
               <span aria-hidden="true">&larr;</span> {{ _('Previous Page') }}
           </a>
       </li>
       <li class="next{% if not next_url %} disabled{% endif %}">
           <a href="{{ next_url or '#' }}">
               {{ _('Next Page') }} <span aria-hidden="true">&rarr;</span>
           </a>
       </li>
   </ul>
</nav>
</div>
{% else %}
<div class="alert alert-warning" role="alert">
    No cars found!!
</div>
{% endif %}

app/templates/home/inventory.html
{% extends "home/base.html" %}
{% block content %}
        <div class="section">
            <div class="container">
                <div class="row">
                    <div class="custom-sidebar col-md-3 col-sm-12">
                        <div class="widget clearfix">
                            <div class="search-tab clearfix">
                                <div class="inner-addon right-addon">
                                    <h3>Filter By</h3>
                                 </div>
                                <!-- Tab panes -->
                                <div class="tab-content">
                                    <div role="tabpanel" class="tab-pane in active" id="tab01">
                                        <div class="search-wrapper">
                                          <form class="row" method="get">
                                                <div class="col-md-12 col-sm-12 col-xs-12">
                                                    <div class="form-input">
                                                      {{form.make(class="form-control")}}
                                                      {%for error in form.make.errors%}
                                                      <span style="color:red">{{error}}</span>
                                                      {% endfor %}
                                                    </div>
                                                    <div class="form-input">
                                                      {{form.model(class="form-control carsearch")}}
                                                      {%for error in form.model.errors%}
                                                      <span style="color:red">{{error}}</span>
                                                      {% endfor %}
                                                    </div><!-- end form-input -->
                                                    <div class="form-input">
                                                      {{form.year(class="form-control carsearch")}}
                                                      {%for error in form.year.errors%}
                                                      <span style="color:red">{{error}}</span>
                                                      {% endfor %}
                                                    </div><!-- end form-input -->
                                                    <div class="form-input">
                                                      {{form.fuel(class="form-control carsearch")}}
                                                      {%for error in form.fuel.errors%}
                                                      <span style="color:red">{{error}}</span>
                                                      {% endfor %}
                                                    </div><!-- end form-input -->
                                                    <div class="form-input">
                                                      {{form.transmission(class="form-control carsearch")}}
                                                      {%for error in form.transmission.errors%}
                                                      <span style="color:red">{{error}}</span>
                                                      {% endfor %}
                                                  </div>
                                                </div><!-- end col -->
                                            </form><!-- end row -->
                                        </div><!-- end search-wrapper -->
                                    </div><!-- end tab-pane -->
                                </div><!-- end tab content -->
                            </div>
                        </div><!-- end widget -->
                        <div class="widget custom-widget clearfix">
                            <div class="stm-filter-gigfilter">
                                <h3>Select Price</h3>
                                <div class="row gigimotors-padding">
                                  <form id="form-min_val" method="post">
                                    <div class="col-md-6 col-sm-6 col-md-wider-right">
                                        <input name="min_price" value="0" onkeyup="postinput()" id="stm_filter_min_price" type="text">
                                    </div>
                                    <div class="col-md-6 col-sm-6 col-md-wider-left">
                                        <input name="max_price" onkeyup="postinput()" id="stm_filter_max_price" value="{% if maxval %}{{ maxval }}{%else%}0{%endif%}" type="text">
                                    </div>
                                  </form>
                                </div>
                            </div>
                        </div><!-- end widget -->
                        <div class="widget custom-widget clearfix">
                            <div class="stm-filter-gigfilter">
                                <h3>Body</h3>
                                <div class="row gigimotors-padding">
                                    <div class="stm-accordion-inner">
                                      <form id="form-checkbox">
                                        <label class="stm-option-label">
                                            <div class="checker">
                                                <span><input name="hatchback" value="hatchback" type="checkbox"></span>
                                            </div>
                                            <span class="gigimotors-plain">Hatchback</span>
                                        </label>
                                        <label class="stm-option-label">
                                            <div class="checker">
                                                <span><input name="pickup" value="pickup" type="checkbox"></span>
                                            </div>
                                            <span class="gigimotors-plain">Pickup</span>
                                        </label>
                                        <label class="stm-option-label">
                                            <div class="checker">
                                                <span><input name="sedan" value="sedan" type="checkbox"></span>
                                            </div>
                                            <span class="gigimotors-plain">Sedan</span>
                                        </label>
                                        <label class="stm-option-label">
                                            <div class="checker">
                                                <span><input name="station-wagons" value="station-wagons" type="checkbox"></span>
                                            </div>
                                            <span class="gigimotors-plain">Wagons</span>
                                        </label>
                                        <label class="stm-option-label">
                                            <div class="checker">
                                                <span><input name="suv" value="suv" type="checkbox"></span>
                                            </div>
                                            <span class="gigimotors-plain">SUV</span>
                                        </label>
                                        <label class="stm-option-label">
                                            <div class="checker">
                                                <span><input name="vans" value="vans" type="checkbox"></span>
                                            </div>
                                            <span class="gigimotors-plain">Vans</span>
                                        </label>
                                      </form>
                                    </div>
                                </div>
                            </div>
                        </div><!-- end widget -->


                    </div><!-- end col -->

                    <div class="col-md-9 col-sm-12">
                        <div class="car-list-wrapper clearfix">
                            <div class="list-top clearfix">
                                <div class="stm-listing-directory-title pull-left">
                                    <h3 class="title">Cars for sale</h3>
                                </div>
                            </div><!-- end list-top -->
                            <div id="inventory-cars">
                            {% include 'home/_post.html' %}
                          </div>

                        </div><!-- end car-list-wrapper -->
                    </div><!-- end col -->
                </div><!-- end row -->
            </div><!-- end container -->
        </div><!-- end section -->
{% endblock %}
{% block scripts %}
  {{super()}}
  <script>
  function postinput(){
    // var send = {
    //     min_val: $(this).val()
    // };
    //   if($(this).val() != ''){
    //     $.getJSON("{{ url_for('home._get_cars') }}", send, function(data) {
    //       Object.keys(data).forEach(function (item)
    //       {
    //       });
    //     });
    //   }
    if($('#min_val').val() != '' && $('#max_val').val() != ''){
      $.ajax({
              method: "get",
              url: "{{ url_for('home._get_cars') }}",
              data: $('#form-min_val').serialize()})
              .done(function(data) {
          $('#inventory-cars').html(data)
        });
  }
}
$(document).ready(function() {
    $( "input[type='checkbox']").on( "click",function() {
      $.ajax({
              method: "get",
              url: "{{ url_for('home._get_body') }}",
              data: $('#form-checkbox').serialize()})
              .done(function(data) {
          $('#inventory-cars').html(data)
        });
    });
});
  </script>
{% endblock %}